
#define VERSION
#include "Arduino.h" 
#include <ESP8266WiFi.h>

#include <ESPAsyncWebServer.h>
#include <ESPAsyncTCP.h>
#include <ESPAsyncTCPbuffer.h>

const char* ssid ="ON_AIR2021";
const char* password = "cGT>1_@?LOdBqD6kd%s@v|.b5x^4PD|?s}uu*j4o)Uqpa|r1jftH+H>8_oG6}v4";

const int PWM_output = 15;  // Lolin Pin D8
#define Led_Verte 0 //  Lolin pin  D3
#define Led_Rouge 12 // Lolin pin  D6
#define Led_Bleue 14 //  Lolin pin  D5
#define Led_Bleu_Inbuilt 2 //  Lolin pin  D4

IPAddress local_IP(192, 168, 0, 110);
// Set your Gateway IP address
IPAddress gateway(192, 168, 0, 254);
IPAddress subnet(255, 255, 0, 0);
IPAddress primaryDNS(212,27,40,241);   //optional
IPAddress secondaryDNS(212,27,40,240);   //optional

String SlideValue = "0";  // init value
String ConsigneValue = "0";
const char* PARAM_INPUT = "value";
const char* PARAM_INPUT1 ="value";

const char* PARAM_OUTPUT = "output";
const char* PARAM_STATE  = "state";

unsigned int i,j,k;
unsigned int Compteur;
char RxBuffer[80];


// Create AsyncWebServer object on port 80
AsyncWebServer server(80);

const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>ESP Async.Web Server</title>
//-----------------------------------------
 <style>
    html {font-family: Arial; display: inline-block; text-align: center;}
    h2 {font-size: 2.0rem;}
	 h3 {font-size: 1.75rem;}
	  h4 {font-size: 1.25rem;}
	    h5 {font-size: 0.5rem;}
    p {font-size: 3.0rem;}
    body {max-width: 500px; margin:20px; padding-bottom: 25;}
    .switch {position: relative; display: inline-block; width: 120px; height: 68px} 
    .switch input {display: none}
    .slider {position: absolute; top: 0; left: 0; right: 0; bottom: 0; background-color: #ccc; border-radius: 6px}
    .slider:before {position: absolute; content: ""; height: 52px; width: 52px;
	left: 8px; bottom: 8px; background-color: #fff; -webkit-transition: 1.4s; transition: 1.4s; border-radius: 6px}
    input:checked+.slider {background-color:   #0F0}
    input:checked+.slider:before {-webkit-transform: translateX(52px); -ms-transform: translateX(52px); transform: translateX(52px)}
 
    .switch1 {position: relative; display: inline-block; width: 120px; height: 68px} 
    .switch1 input {display: none}
    .slider1 {position: absolute; top: 0; left: 0; right: 0; bottom: 0; background-color: #ccc; border-radius: 6px}
    .slider1:before {position: absolute; content: ""; height: 52px; width: 52px;
	left: 8px; bottom: 8px; background-color: #fff; -webkit-transition: 1.4s; transition: 1.4s; border-radius: 6px}
    input:checked+.slider1 {background-color: #b30000}
    input:checked+.slider1:before {-webkit-transform: translateX(52px); -ms-transform: translateX(52px); transform: translateX(52px)}
	
	.switch2 {position: relative; display: inline-block; width: 120px; height: 68px} 
    .switch2 input {display: none}
    .slider2 {position: absolute; top: 0; left: 0; right: 0; bottom: 0; background-color: #ccc; border-radius: 6px}
    .slider2:before {position: absolute; content: ""; height: 52px; width: 52px;
	left: 8px; bottom: 8px; background-color: #fff; -webkit-transition: 1.4s; transition: 1.4s; border-radius: 6px}
    input:checked+.slider2 {background-color: #00F}
    input:checked+.slider2:before {-webkit-transform: translateX(52px); -ms-transform: translateX(52px); transform: translateX(52px)}

  </style>
 <script>function toggleCheckbox(element) {
  var xhr = new XMLHttpRequest();
  if(element.checked){ xhr.open("GET", "/update?output="+element.id+"&state=1", true); }
  else { xhr.open("GET", "/update?output="+element.id+"&state=0", true); }
  xhr.send();
}
</script>  

























    //------------------------------------------------------------
    <style>
      html {
        font-family: Arial;
        display: inline-block;
        text-align: left;
      }
      h2 {
        font-size: 2rem;
      }
      h3 {
        font-size: 1.75rem;
      }
      h4 {
        font-size: 1.25rem;
      }
      h5 {
        font-size: 0.625rem;
      }

      p {
        font-size: 1.0rem;
      }
      body {
        max-width: 400px;
        max-height: 80px;
        margin: 20px ;
        padding-bottom: 25px;
      }
      .slider {
        -webkit-appearance: none;
        margin: 5px;
        width: 360px;
        height: 20px;
        background: #e7b213;
        outline: black;
        -webkit-transition: 3.6s;
        transition: opacity 1.6s;
      }
      .slider::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 15px;
        height: 36px;
        background: #489118;
        cursor: pointer;
      }

      body {
        max-width: 400px;
        max-height: 80px;
        margin: 10px;
        padding-bottom: 20px;
      }
      .consigne {
        -webkit-appearance: none;
        margin: 10px;
        width: 360px;
        height: 20px;
        background: rgb(180, 6, 58);
        outline: none;
        -webkit-transition: 0.6s;
        transition: opacity 2.6s;
      }
      .consigne::-webkit-slider-thumb {
        -webkit-appearance: none;
        appearance: none;
        width: 30px;
        height: 30px;
        background: #2b0594;
        cursor: pointer;
      }
    
       .switch {
        position: relative;
        display: inline-block;
        width: 60px;
        height: 40px;
      }
      .switch input {
        display: none;
      }
      .slider0 {
        position: absolute;
        top: 200;
        left: 20;
        right: 40;
        bottom: 210;
        background-color: #ccc;
        border-radius: 3px;
      }
      .slider0:before {
        position: absolute;
        content: '';
        height: 25px;
        width: 25px;
        left: 8px;
        bottom: 8px;
        background-color: #fff;
        -webkit-transition: 0.5s;
        transition: 0.5s;
        border-radius: 3px;
      }
      input:checked + .slider0 {
        background-color: #0f0;
      }
      input:checked + .slider0:before {
        -webkit-transform: translateX(52px);
        -ms-transform: translateX(25px);
        transform: translateX(25px);
      }

      .switch1 {
        position: relative;
        display: inline-block;
        width: 120px;
        height: 68px;
      }
      .switch1 input {
        display: none;
      }
      .slider1 {
        position: absolute;
        top: 400;
        left: 20;
        right: 40;
        bottom: 42;
        background-color: #ccc;
        border-radius: 6px;
      }
      .slider1:before {
        position: absolute;
        content: '';
        height: 52px;
        width: 52px;
        left: 8px;
        bottom: 8px;
        background-color: #fff;
        -webkit-transition: 0.5s;
        transition: 0.5s;
        border-radius: 6px;
      }
      input:checked + .slider1 {
        background-color: #b30000;
      }
      input:checked + .slider1:before {
        -webkit-transform: translateX(52px);
        -ms-transform: translateX(52px);
        transform: translateX(52px);
      }

      .switch2 {
        position: relative;
        display: inline-block;
        width: 120px;
        height: 68px;
      }
      .switch2 input {
        display: none;
      }
      .slider2 {
        position: absolute;
        top: 300;
        left: 0;
        right: 0;
        bottom: 0;
        background-color: #ccc;
        border-radius: 6px;
      }
      .slider2:before {
        position: absolute;
        content: '';
        height: 52px;
        width: 52px;
        left: 8px;
        bottom: 8px;
        background-color: #fff;
        -webkit-transition: 0.5s;
        transition: 0.5s;
        border-radius: 6px;
      }
      input:checked + .slider2 {
        background-color: #00f;
      }
      input:checked + .slider2:before {
        -webkit-transform: translateX(52px);
        -ms-transform: translateX(52px);
        transform: translateX(52px);
      }
    </style>

 <script>
 function updateSliderPWM(element) {
  var SlideValue = document.getElementById("pwmSlider").value;
  document.getElementById("textSlideValue").innerHTML = SlideValue;
 // console.log(SlideValue);
  var xhr0 = new XMLHttpRequest();
  xhr0.open("GET", "/slider?value="+SlideValue, true);
  xhr0.send();
}

function updateConsigne(element) {
  var ConsigneValue = document.getElementById("consigne").value;
  document.getElementById("textConsigneValue").innerHTML =ConsigneValue;
 // console.log(Consigne);
  var xhr1 = new XMLHttpRequest();
  xhr1.open("GET", "/consigne?value="+ConsigneValue, true);
  xhr1.send();
}
 </script>
   

  </head>
  <body>
    <h2>ESP8266 Lolin Jaune Async.Web server</h2>
    <br />
    <h5>ESP8266_Jaune_Buttons_Slider_PWM_2021-0727.ino</h5>
    <br />
    <br />

    <p> 
      <h5> Cde PWM -- >  <b>
      <span  style="color:blue" id="textSlideValue">%SlideValue%</span>
     </b></h5>
     </p>
    <p>
    
      <input
        type="range"
        onchange="updateSliderPWM(this)"
        id="pwmSlider"
        max="1023"
        min="0"
        value="%SlideValue%"
        step="1"
        class="slider"
      />
    </p>

    <p> 
      <h5>CONSIGNE.Vitesse --> <b>
      <span  style="color:red"  id="textConsigneValue">%CONSIGNEVALUE%</span>
      </b> </h5> 
     </p>
    <p>
       <input
        type="range"
        onchange="updateConsigne(this)"
        id="consigne"
        max="990"
        min="10"
        value="%CONSIGNEVALUE%"
        step="1"
        class="consigne"
      />
    </p>

    <h3>Cde Sorties GPIO</h3>
       %BUTTONPLACEHOLDER%  
    
   <script>
      function toggleCheckbox(element) {
        var xhr2 = new XMLHttpRequest()
        if (element.checked) {
          xhr2.open('GET', '/update?output=' + element.id + '&state=1', true)
        } else {
          xhr2.open('GET', '/update?output=' + element.id + '&state=0', true)
        }
        xhr2.send()
      }
    </script>
    <br>
  </body>
</html>
)rawliteral";


String outputState(int output){
  if(digitalRead(output)){
    return "checked";
  }
  else {
    return "";
  }
}

String processor(const String& var)
{
 
   Serial.println("Processor");Serial.println(var);
 
 if(var == "BUTTONPLACEHOLDER")
 {
    String buttons = "";
    buttons += "<h4>Led Verte GPIO 04</h4><label class=\"switch\"><input type=\"checkbox\" onchange=\"toggleCheckbox(this)\" id=\"0\" " + outputState(0) + "><span class=\"slider\"></span></label>";
    buttons += "<h4>Led Rouge GPIO 12</h4><label class=\"switch1\"><input type=\"checkbox\" onchange=\"toggleCheckbox(this)\" id=\"12\" " + outputState(12) + "><span class=\"slider1\"></span></label>";
    buttons += "<h4>Led_Bleue GPIO 14</h4><label class=\"switch2\"><input type=\"checkbox\" onchange=\"toggleCheckbox(this)\" id=\"14\" " + outputState(14) + "><span class=\"slider2\"></span></label>";
    return buttons;
  }
   if ((var == "SlideValue") or (var == "CONSIGNEVALUE"))
  {
  if (var == "SlideValue")  return SlideValue;
  if (var == "CONSIGNEVALUE")     return ConsigneValue;
  }
}


void setup(){
  // Serial port for debugging purposes
  Serial.begin(115200);
  delay(200);
  Compteur=0;
  Serial.println();
  pinMode(Led_Verte, OUTPUT);
  pinMode(Led_Bleue, OUTPUT);
  pinMode(Led_Rouge, OUTPUT);    // led rouge externe sur Lolin pin D6 (GPio 12)
  digitalWrite(Led_Rouge, LOW);
  digitalWrite(Led_Verte, LOW);
  digitalWrite(Led_Bleue, LOW);
 
  Serial.print(" ESP8266MOD Lolin NodeMCU Jaune 2x15 pins \r\n Test PWM rev "VERSION"\r\n");
  Serial.println(" ESP8266_Jaune_Slider_PWM_2022-xxxx.ino");
  Serial.println(" Led Bleue sur D4 pull down  (et in-built pull up)");
  Serial.println(" Led Verte sur D3 (GPIO 0) pull down");
  Serial.println(" Led Rouge sur D6 (GPIO 12) pull Down");
  Serial.println(" Init PWM (GPIO 15)  => sortie sur Pin D8 module Lolin ");
   // sortie PWM
  analogWriteRange(1023);
  analogWrite(PWM_output, SlideValue.toInt());  // Lolin pin D8
  analogWriteFreq(2000);
 
   // Configures static IP address
  if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS))
   {
    Serial.println("STA Failed to configure");
  } 
  // Connect to Wi-Fi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }
  // Print ESP Local IP Address
  Serial.println(WiFi.localIP());

  // Route for root / web page
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
  {   // request->send_P(200, "text/html", index_html, Bouttons);
        request->send_P(200, "text/html", index_html, processor);  
        });
 
  
 // Send a GET request to <ESP_IP>/slider?value=<inputMessage>
  server.on("/consigne", HTTP_GET, [] (AsyncWebServerRequest *request) 
    {
    String inputMessage;
    // GET input1 value on <ESP_IP>/consigne?value=<inputMessage>
    if (request->hasParam(PARAM_INPUT1)) {
      inputMessage = request->getParam(PARAM_INPUT1)->value();
      ConsigneValue = inputMessage;
     analogWrite(PWM_output, ConsigneValue.toInt());
    //  Serial.print( " Consigne=");Serial.println(inputMessage);
       }
    else {
      inputMessage = "No message sent";
    }
        Serial.print( " Consigne=");Serial.println(inputMessage);
       request->send(200, "text/plain", "OK");
  });

  // Send a GET request to <ESP_IP>/slider?value=<inputMessage>
  server.on("/slider", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage;
    // GET input value on <ESP_IP>/slider?value=<inputMessage>  
    if (request->hasParam(PARAM_INPUT))
      {
        inputMessage = request->getParam(PARAM_INPUT)->value();
        SlideValue = inputMessage;
        analogWrite(PWM_output, SlideValue.toInt());
      //   Serial.print( " Slider=");Serial.println(inputMessage);
       }
      else
       {
         inputMessage = "No message sent";
       }
       Serial.print( " Slider=");Serial.println(inputMessage);
       request->send(200, "text/plain", "OK");
      });

      // Send a GET request to <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
  
  server.on("/update", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage1;
    String inputMessage2;
    
    // GET input1 value on <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
    if (request->hasParam(PARAM_OUTPUT) && request->hasParam(PARAM_STATE)) {
      inputMessage1 = request->getParam(PARAM_OUTPUT)->value();
      inputMessage2 = request->getParam(PARAM_STATE)->value();
      digitalWrite(inputMessage1.toInt(), inputMessage2.toInt());
    }
    else {
      inputMessage1 = "No message sent";
      inputMessage2 = "No message sent";
    }
    Serial.print("GPIO: ");
    Serial.print(inputMessage1);
    Serial.print(" - Set to: ");
    Serial.println(inputMessage2);
    request->send(200, "text/plain", "OK");
  });
       
  // Start server
  server.begin();
 
}
  
void loop()
 {
  Serial.printf ("Cp1t= %05d",Compteur);
 Serial.printf("Slider Value %05d ",SlideValue);
 Serial.printf("Consigne value %05d",ConsigneValue);
  delay(1500);
  Compteur++;
  if (Compteur && 0x0001==1)  
  digitalWrite(Led_Bleu_Inbuilt,HIGH);
  else 
  digitalWrite(Led_Bleu_Inbuilt,LOW);

  //  Serial.readBytesUntil('\r',RxBuffer,32);
  // if (sizeof(RxBuffer)>0) Serial.println(RxBuffer);
}

/*




--------- sur terminal YAT 115200 bds  COM48 -----------
 Test PWM rev 22/07/2021
 ESP8266_Jaune_Slider_PWM_2021-0723.ino
 Led Rouge sur D6 (GPIO 12) pull Down
 Init PWM sortie 2  => Pin D4 module Lolin (
Connecting to WiFi..
Connecting to WiFi..
Connecting to WiFi..
Connecting to WiFi..
192.168.0.110
 Consigne=186
 Consigne=337
 Consigne=532
 Consigne=595
 Consigne=759
 Consigne=913
 Consigne=1023
 Consigne=545
 Consigne=378
 Consigne=154

*/
